using Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses;
using Bp.Sync.Domain.Entities.FcBusinesses;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.FcBusinesses.InboundStatistics
{
    public class SyncInboundStatisticHandler : MediatR.IRequestHandler<SyncInboundStatisticCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IInboundStatisticRepository _InboundStatisticRepository;
        private readonly IBus _bus;

        public SyncInboundStatisticHandler(IConfiguration configuration, IInboundStatisticRepository InboundStatisticRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcBusinessConnection");
            _dbConnection = new SqlConnection(connectionString);
            _InboundStatisticRepository = InboundStatisticRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncInboundStatisticCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticInboundStatistic", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} InboundStatistics" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var InboundStatistics = await _dbConnection.QueryAsync<InboundStatistic>("Sync_InboundStatistic_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (InboundStatistics.Any())
                {
                    var inbounds = InboundStatistics.ToInboundStatistics();

                    //lay ra danh sach inbound bill
                    var billids = inbounds.Select(x => x.BillId).Distinct().ToList();
                    var p2 = new Dto.DapperTypes.IdsParam(billids);
                    var bills = await _dbConnection.QueryAsync<Domain.Entities.FcBusinesses.Bills.InboundBill>("Sync_InboundBill_Get_By_List_Id", p2, commandType: CommandType.StoredProcedure);

                    foreach (var item in inbounds)
                    {
                        var bill = bills.FirstOrDefault(x => x.Id == item.BillId);
                        item.BillIsDeleted = bill?.IsDeleted;
                        item.BillStatus = bill?.BillStatus;
                        item.BillType = bill?.BillType;
                        item.BillCreatedTime = bill?.CreatedTime;
                        item.BillCompletedDate = bill?.CompletedDate;
                        item.BillPartnerId = bill?.PartnerId;
                        item.BillOriginBranchId = bill?.OriginBranchId;
                        item.BillDestinationBranchId = bill?.DestinationBranchId;
                    }

                    var rs2 = await _InboundStatisticRepository.AddManyAsync(inbounds);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_InboundStatistic_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{inbounds.Count()} synced";
                        rs.Result = Result.Success;
                        await _bus.SendAsync($"SyncToElasticFcProductInbound", request.Ids.ConvertListLongToString());
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}